//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "malden"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color3  DeepSkyBlue  
#property indicator_color4  DimGray
#property indicator_color5  PaleVioletRed
#property indicator_color6  DeepSkyBlue
#property indicator_width6  2
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT

//
//
//
//
//

extern int    RsiPeriod    =   14;
extern int    RsiPrice     = PRICE_CLOSE;
extern int    MinMaxPeriod =  200;
extern double LevelUp      = 76.4;
extern double LevelDown    = 23.6;

//
//
//
//
//

double rsiMin[];
double rsiMax[];
double rsiLUp[];
double rsiLMi[];
double rsiLDn[];
double rsi[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsiMin); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,rsiMax); SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(2,rsiLUp);
   SetIndexBuffer(3,rsiLMi);
   SetIndexBuffer(4,rsiLDn);
   SetIndexBuffer(5,rsi);
      IndicatorShortName("RSI ("+RsiPeriod+","+DoubleToStr(LevelDown,2)+","+DoubleToStr(LevelUp,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) 
   {
      rsi[i]    = iRSI(NULL,0,RsiPeriod,PRICE_CLOSE,i);
      rsiMin[i] = rsi[ArrayMinimum(rsi,MinMaxPeriod,i)];
      rsiMax[i] = rsi[ArrayMaximum(rsi,MinMaxPeriod,i)];
         double range = rsiMax[i]-rsiMin[i];
            rsiLDn[i] = rsiMin[i]+range*LevelDown/100.0;
            rsiLMi[i] = rsiMin[i]+range*0.5;
            rsiLUp[i] = rsiMin[i]+range*LevelUp/100.0;
   }      
   return(0);
}